import { dispatch, reducers, run, sagas, stop } from '../types/service';
import { ID } from '../types/symbol';
import AppService from './AppService';
export default class DefaultGlobalService extends AppService {
    [run]() {
        this[dispatch] = this.context.store.dispatch;
        this.context.store.injectReducers(this, this.constructor[ID], this[reducers]);
        Object.keys(this[sagas]).forEach((type) => {
            this.context.store.runSaga(this.constructor[ID], this[sagas][type], type);
        });
    }
    [stop]() {
        this[dispatch] = null;
        this.context.store.removeReducers(this.constructor[ID], this[reducers]);
        Object.keys(this[sagas]).forEach((type) => {
            this.context.store.cancelSaga(this.constructor[ID], type);
        });
    }
}
//# sourceMappingURL=GlobalService.js.map