import { AppSettings } from '../types/app';
import { AnonymousObject } from '../types/object';
import AppContext from './AppContext';
export declare const defaultSettings: {
    contextPath: string;
    i18n: {
        locales: never[];
        defaultLocale: undefined;
        url: string;
        slug: string;
        localeFromLocation: (location: Location, settings: AppSettings) => string | undefined;
        addLocaleToLocation: (locale: string, location: Location, settings: AppSettings) => Location;
        changeLocale: (locale: string, { router, settings, i18n }: AppContext) => void;
    };
    idp: {};
    notification: {
        default: {
            ttl: number;
            max: number;
        };
        error: {
            ttl: number;
            max: number;
        };
        'login-error': {
            ttl: number;
            max: number;
        };
        'logout-error': {
            ttl: number;
            max: number;
        };
        warning: {
            ttl: number;
            max: number;
        };
    };
    router: {
        type: string;
    };
    routes: {
        login: string;
        loginCallback: string;
        logout: string;
        logoutCallback: string;
        home: string;
    };
};
export declare const defaultIdpSettings: AnonymousObject;
export declare const indexLocales: (settings: AppSettings) => AppSettings;
