import 'reflect-metadata';
import useLazyRef from '../core/useLazyRef';
import useAppContext from './useAppContext';
import useContainer from './useContainer';
const useAppService = (ctor, initialState) => {
    const appContext = useAppContext();
    const container = useContainer();
    const serviceRef = useLazyRef(() => {
        const service = container.createService(ctor, appContext, initialState);
        return service;
    });
    return serviceRef.current;
};
export default useAppService;
//# sourceMappingURL=useAppService.js.map