import { useCallback } from 'react';
import { useSelector } from 'react-redux';
import { get } from '../utils/object';
import GlobalStateService from './GlobalStateService';
import useGlobalService from './useGlobalService';
// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
function useGlobalState(key, defaultValue) {
    let value = useSelector((state) => get(state, key));
    value = value === undefined ? defaultValue : value;
    const service = useGlobalService(GlobalStateService);
    const setValue = useCallback((value) => {
        service.setState(key, value);
    }, [service, key]);
    return [value, setValue];
}
export default useGlobalState;
//# sourceMappingURL=useGlobalState.js.map