import { useCallback } from 'react';
import LocalStateService from './LocalStateService';
import useLocalService from './useLocalService';
export const useLocalState = (initialState) => {
    const [state, service] = useLocalService(LocalStateService, initialState);
    const setState = useCallback((key, value) => {
        service.setState(key, value);
    }, [service]);
    return [state, setState];
};
//# sourceMappingURL=useLocalState.js.map