import React, { useEffect } from 'react';
import useRouter from '../app/useRouter';
import useSetting from '../app/useSetting';
const DefaultAuthErrorComponent = ({ error }) => {
    const router = useRouter();
    const loginRoute = useSetting('routes.login', '/login');
    useEffect(() => {
        if (error.code === 401) {
            router.push(loginRoute);
        }
    }, [error.code, router, loginRoute]);
    if (error.code === 401) {
        return null;
    }
    return React.createElement("div", null,
        "ERROR ",
        error.code);
};
export default DefaultAuthErrorComponent;
//# sourceMappingURL=DefaultAuthErrorComponent.js.map