import React, { memo } from 'react';
import useGlobalProp from '../app/useGlobalProp';
import DefaultAuthErrorComponent from './DefaultAuthErrorComponent';
import useSecurityContext from './useSecurityContext';
export const secure = (Component, validator, options = {}) => {
    const identity = options.identity ?? 'default';
    const SecureComponent = memo((props) => {
        const [securityContext, loading] = useSecurityContext(undefined, undefined, identity);
        const auth = useGlobalProp(`auth.${identity}`);
        // const [error, setError] = useState(null);
        const ErrorComponent = options.ErrorComponent || DefaultAuthErrorComponent;
        const error = {
            code: 401,
        };
        // const onError = useCallback(
        //   (e) => {
        //     setError(e);
        //     setLoading(false);
        //   },
        //   [setLoading, setError],
        // );
        // useEffect(() => {
        //   if (!loading && !securityContext && !error) {
        //     setLoading(true);
        //     authService.fetchSecurityContext(onError, () => {
        //       setLoading(false);
        //     });
        //   }
        // }, [authService, onError, error, loading, securityContext]);
        if (!loading && securityContext !== undefined) {
            if (securityContext) {
                if (validator && !validator(securityContext)) {
                    // Example: user doesn't have the required role
                    error.code = 403;
                    return React.createElement(ErrorComponent, { error: error });
                }
                else {
                    return React.createElement(Component, { ...props, securityContext: securityContext, auth: auth });
                }
            }
            else {
                return React.createElement(ErrorComponent, { error: error });
            }
        }
        else if (loading) {
            return React.createElement("div", null, "Loading...");
        }
        return null;
    });
    SecureComponent.displayName = 'SecureComponent';
    SecureComponent.getLayout = Component.getLayout;
    return SecureComponent;
};
//# sourceMappingURL=secure.js.map