import { useEffect, useState } from 'react';
import useGlobalProp from '../app/useGlobalProp';
import { get } from '../utils/object';
import useAuthService from './useAuthService';
// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
function useSecurityContext(selector, defaultValue, identity = 'default') {
    const [loading, setLoading] = useState(false);
    const securityContext = useGlobalProp(`auth.${identity}.securityContext`);
    const authService = useAuthService();
    useEffect(() => {
        if (securityContext !== undefined) {
            setLoading(false);
        }
        else {
            setLoading(true);
            authService.fetchSecurityContext(() => {
                setTimeout(() => {
                    authService.setSecurityContext(null, identity);
                }, 0);
            }, undefined, identity);
        }
    }, [authService, securityContext, identity]);
    return [get(securityContext, selector, defaultValue), loading];
}
export default useSecurityContext;
//# sourceMappingURL=useSecurityContext.js.map