import { AppContext, AppSettings } from '../types/app';
import { AnonymousObject } from '../types/object';
import { AnyState } from '../types/state';
import { Idp, IdpSettings } from './typings';
export declare const oauth2Keys: string[];
export declare function generateCodeChallenge(codeVerifier: string): Promise<string>;
export declare function generateCodeVerifier(): string;
export declare function generateNonce(): string;
export declare function generateState(): string;
export declare function getIdp(settings: AppSettings, name?: string): Idp;
export declare function idpForm(idpConfig: IdpSettings): Idp;
export declare function external(idpConfig: IdpSettings): Idp;
export declare function oidcServer(idpConfig: IdpSettings): Idp;
export declare function oidcBrowser(idpConfig: IdpSettings): Idp;
export declare function getIdpName(state: AnyState, identity?: string): string | undefined;
export declare function parseJwt(token: string, section?: string): any;
export declare function validateToken(token: string, jwksEndpoint: string | ((token: string, idp: Idp, context: AppContext) => string), idp: Idp, context: AppContext): Promise<boolean>;
export declare const isOauth: (idp: Idp) => boolean;
export declare const isExternal: (idp: Idp) => boolean;
/**
 * Parse the token from the location hash
 *
 * @param {object} hash : the location hash (anything after the # in the URL)
 */
export declare const parseHashToken: (hash: AnonymousObject) => AnonymousObject;
export declare const getIdpStorage: (idp: Idp) => Storage;
