import { useEffect } from 'react';
import useService from '../core/useService';
import { isCollection } from './utils';
const useCollectionService = (ctor, initialState) => {
    const [state, service] = useService(ctor, initialState);
    useEffect(() => {
        if (initialState.fetchOnce) {
            service._fetchOnce();
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    useEffect(() => {
        if (!isCollection(initialState.dataSource) && initialState.autoload && !initialState.local) {
            service.load(initialState.limit, initialState.offset);
        }
        return () => {
            service.destroy();
        };
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    return [state, service];
};
export default useCollectionService;
//# sourceMappingURL=useCollectionService.js.map