export default class DefaultBasicError extends Error {
    code;
    payload;
    message;
    constructor(message, code, payload = {}) {
        super(message);
        this.code = code || 'default';
        this.payload = payload;
        this.message = message;
    }
    static of(error) {
        if (error instanceof Error) {
            return new DefaultBasicError(error.message, error.name, { stack: error.stack });
        }
        if (error.constructor === Object) {
            return new DefaultBasicError(error['message'], error['code'], error['payload']);
        }
        return new DefaultBasicError('Unexpected exception', 'unexpected', { original: error });
    }
}
//# sourceMappingURL=BasicError.js.map