import { useRef } from 'react';
import { isFunction } from '../utils/type';
const useLazyRef = (initialValue) => {
    const ref = useRef(null);
    const initializeRef = () => {
        if (ref.current === null) {
            ref.current = isFunction(initialValue) ? initialValue() : initialValue;
        }
    };
    initializeRef();
    return ref;
};
export default useLazyRef;
//# sourceMappingURL=useLazyRef.js.map