import 'reflect-metadata';
import { create } from '../types/service';
import { handler } from './Service';
import useLazyRef from './useLazyRef';
import useLocalReducer from './useLocalReducer';
const useService = (ctor, initialState) => {
    const initialStateRef = useLazyRef(initialState);
    const serviceRef = useLazyRef(() => {
        const service = new ctor();
        service[create](initialStateRef.current);
        return new Proxy(service, handler);
    });
    return useLocalReducer(serviceRef.current, initialStateRef.current);
};
export default useService;
//# sourceMappingURL=useService.js.map