/* eslint-disable @typescript-eslint/ban-types */
import { useMemo, useRef } from 'react';
const useThrottle = (fn, delayMs) => {
    const argsRef = useRef();
    const delayRef = useRef(false);
    const result = useMemo(() => {
        return ((...args) => {
            if (!delayRef.current) {
                delayRef.current = true;
                fn(...args);
                setTimeout(() => {
                    delayRef.current = false;
                    if (argsRef.current !== undefined) {
                        const args = argsRef.current;
                        argsRef.current = undefined;
                        fn(...args);
                    }
                }, delayMs);
            }
            else {
                argsRef.current = args;
            }
        });
    }, [fn, delayMs]);
    return result;
};
export default useThrottle;
//# sourceMappingURL=useThrottle.js.map