import { useCallback } from 'react';
import FetchService from '../core/FetchService';
import useService from '../core/useService';
import { useFetchOptions } from './useFetchOptions';
const useDelete = (url, options = {}) => {
    const fetchOptions = useFetchOptions(options);
    const [state, service] = useService(FetchService, {
        loading: false,
    });
    const executor = useCallback((extraOptions = {}) => {
        extraOptions = Object.assign({}, fetchOptions, extraOptions);
        service.delete(extraOptions.url || url, extraOptions);
    }, [service, url, fetchOptions]);
    return [executor, state.loading || false];
};
export default useDelete;
//# sourceMappingURL=useDelete.js.map