import { useCallback } from 'react';
import FetchService from '../core/FetchService';
import useService from '../core/useService';
import { useFetchOptions } from './useFetchOptions';
const usePostPutPatch = (url, method, options = {}) => {
    const fetchOptions = useFetchOptions(options);
    const [state, service] = useService(FetchService, {
        loading: false,
    });
    const executor = useCallback(async (body, extraOptions = {}) => {
        extraOptions = Object.assign({}, fetchOptions, extraOptions);
        await service.fetch(extraOptions.url || url, method, body, extraOptions);
    }, [service, url, method, fetchOptions]);
    return [executor, state.loading || false];
};
export default usePostPutPatch;
//# sourceMappingURL=usePostPutPatch.js.map