import { ValidationStatus } from '../types/form';
import { ValidationCode } from './typings';
export default class FieldValidation {
    message;
    status;
    code;
    constructor(message, status, code) {
        this.message = message;
        this.status = status;
        this.code = code;
    }
    isLoading() {
        return this.code === ValidationCode.Loading;
    }
    isNotLoading() {
        return this.code !== ValidationCode.Loading;
    }
    isError() {
        return this.code === ValidationCode.Error;
    }
    isWarning() {
        return this.code === ValidationCode.Warning;
    }
    isOK() {
        return this.code === ValidationCode.Ok;
    }
    isNotOK() {
        return this.code < ValidationCode.Ok;
    }
    isValidated() {
        return this.code === ValidationCode.None;
    }
    isNotValidated() {
        return this.code !== ValidationCode.None;
    }
    equals(otherValidation) {
        if (!otherValidation) {
            return false;
        }
        return (otherValidation.message === this.message &&
            otherValidation.status === this.status &&
            otherValidation.code === this.code);
    }
}
export const defaultValidation = new FieldValidation('', ValidationStatus.None, ValidationCode.None);
//# sourceMappingURL=FieldValidation.js.map