import React from 'react';
import { extractValidators } from '../utils';
import useField from '../useField';
const Select = React.memo((props) => {
    const [validators, wrappedProps] = extractValidators(props);
    const { name, defaultValue, ...selectProps } = wrappedProps;
    const field = useField(name, validators, {
        defaultValue: defaultValue === undefined ? '' : defaultValue,
    });
    return React.createElement("select", { ...selectProps, ...field });
});
Select.displayName = 'Select';
export default Select;
//# sourceMappingURL=Select.js.map