import React from 'react';
import { ValidationCode } from '../typings';
import useSubmit from '../useSubmit';
const SubmitButton = React.memo((opts) => {
    const { submitting, code, fields } = useSubmit();
    const { showErrors, ...props } = opts;
    let disabled = false;
    const alt = [];
    if (code <= ValidationCode.Error && showErrors) {
        alt.push([`Some fields are ${code === ValidationCode.Error ? 'in error' : 'loading'}`]);
        // disabled = true;
        Object.keys(fields).forEach((fieldName) => {
            alt.push(`<${fieldName}>: ${fields[fieldName]}`);
        });
    }
    // eslint-disable-next-line react/prop-types
    let children = props.children;
    if (submitting) {
        children = React.createElement(React.Fragment, null, "Loading...");
        disabled = true;
    }
    return (React.createElement("button", { title: alt.join('\n'), disabled: disabled, ...props, type: "submit" }, children));
});
SubmitButton.displayName = 'SubmitButton';
export default SubmitButton;
//# sourceMappingURL=SubmitButton.js.map