import React from 'react';
import { extractValidators } from '../utils';
import useField from '../useField';
const Textarea = React.memo((props) => {
    const [validators, wrappedProps] = extractValidators(props);
    const { name, defaultValue, ...textareaProps } = wrappedProps;
    const field = useField(name, validators, {
        defaultValue: defaultValue === undefined ? '' : defaultValue,
    });
    return React.createElement("textarea", { ...textareaProps, ...field });
});
Textarea.displayName = 'Textarea';
export default Textarea;
//# sourceMappingURL=Textarea.js.map