/* eslint-disable @typescript-eslint/no-explicit-any */
import { useCallback, useEffect } from 'react';
import useService from '../core/useService';
import AsyncBindService from './AsyncBindService';
const useAsyncBind = (binder, dependencies = []) => {
    const [state, service] = useService(AsyncBindService, {
        loading: true,
        result: undefined,
        error: undefined,
    });
    // eslint-disable-next-line react-hooks/exhaustive-deps
    const binderCallback = useCallback(binder, dependencies);
    useEffect(() => {
        service.execute(binderCallback, dependencies);
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [binderCallback, ...dependencies]);
    return [state.result, state.loading || false, state.error];
};
export default useAsyncBind;
//# sourceMappingURL=useAsyncBind.js.map