import { useEffect, useRef } from 'react';
import useForm from './useForm';
const useFormDecorator = (name, options = {}) => {
    const form = useForm();
    const decorator = form.initDecorator(name, options);
    const optionsRef = useRef(options);
    const nameRef = useRef(name);
    useEffect(() => {
        if (!form.initializing) {
            if (optionsRef.current.disabled) {
                form.setMetadata(nameRef.current, 'disabled', optionsRef.current.disabled);
            }
            if (optionsRef.current.visible === false) {
                form.setMetadata(nameRef.current, 'visible', optionsRef.current.visible);
            }
        }
    }, [decorator, form]);
    return decorator;
};
export default useFormDecorator;
//# sourceMappingURL=useFormDecorator.js.map