import { useCallback, useEffect, useId, useMemo, useState } from 'react';
export function useFormInit(form, listener) {
    const id = useId();
    const [result, setResult] = useState();
    const valueListener = useCallback((value, previousValue) => {
        const listenerResult = listener(value, previousValue, '');
        setResult(listenerResult);
    }, [listener]);
    useMemo(() => {
        form.onValueChange(id, valueListener, '', true);
    }, [form, id, valueListener]);
    useEffect(() => {
        return () => {
            form.offValueChange(id);
        };
    }, [form, id]);
    return result;
}
export default useFormInit;
//# sourceMappingURL=useFormInit.js.map