import { useEffect, useId, useRef, useState } from 'react';
import useForm from './useForm';
const useFormMetadata = (fieldName) => {
    const form = useForm();
    const id = useId();
    const nameRef = useRef(fieldName);
    const [metadata, setMetadata] = useState(form.state.metadata[fieldName] || {});
    useEffect(() => {
        const watch = [nameRef.current || ''];
        const listener = (metadata) => setMetadata(metadata);
        form.onMetadataChange(id, listener, watch);
        return () => {
            form.offMetadataChange(id);
        };
    }, [form, id]);
    return metadata;
};
export default useFormMetadata;
//# sourceMappingURL=useFormMetadata.js.map