import { useEffect, useId, useRef, useState } from 'react';
import { get, isNullOrEmpty } from '../utils/object';
import useForm from './useForm';
const useValue = (fieldName) => {
    const form = useForm();
    const id = useId();
    const nameRef = useRef(fieldName || '');
    const [value, setValue] = useState(() => {
        if (isNullOrEmpty(nameRef.current)) {
            return form.state.values;
        }
        return get(form.state.values, nameRef.current);
    });
    useEffect(() => {
        const watch = [nameRef.current || ''];
        const listener = (value) => setValue(value);
        form.onValueChange(id, listener, watch);
        return () => {
            form.offValueChange(id);
        };
    }, [form, id]);
    return value;
};
export default useValue;
//# sourceMappingURL=useValue.js.map