import { isNullOrEmpty } from '../../utils/object';
const integer = (message) => {
    return (value) => {
        if (isNullOrEmpty(value) || (typeof value === 'string' && /^\d+$/.test(value)) || Number.isInteger(value)) {
            return {
                valid: true,
                message: undefined,
            };
        }
        if (!message) {
            message = `Invalid value. Must be an integer`;
        }
        return {
            valid: false,
            message,
        };
    };
};
export default integer;
//# sourceMappingURL=integer.js.map