import useGlobalProp from '../app/useGlobalProp';
import { pick, toArray } from '../utils/object';
const mergeNotifications = (a, b) => {
    return a.concat(b).sort((a, b) => a.timestamp - b.timestamp);
};
const extractNotifications = (notifications, accumulator) => {
    if (Array.isArray(notifications))
        return mergeNotifications(accumulator, notifications);
    return Object.keys(notifications).reduce((accumulator, key) => {
        if (notifications[key] !== undefined) {
            return mergeNotifications(notifications[key], accumulator);
        }
        return accumulator;
    }, accumulator);
};
const useNotifications = (topics) => {
    let notifications = useGlobalProp('notifications') || {};
    if (topics) {
        notifications = pick(notifications, toArray(topics));
    }
    return extractNotifications(notifications, []);
};
export default useNotifications;
//# sourceMappingURL=useNotifications.js.map