import Router from './Router';
import { toLocation } from './utils';
let uid = 0;
export default class LocalRouter extends Router {
    listeners;
    constructor() {
        super();
        this.listeners = {};
        this.replace({ pathname: '' });
    }
    back() {
        throw new Error('Method not implemented.');
    }
    forward() {
        throw new Error('Method not implemented.');
    }
    get location() {
        return this.history[0];
    }
    getLinkComponent() {
        throw new Error('Method not implemented.');
    }
    push(urlOrLocation) {
        this._pushOrReplace(urlOrLocation, false);
    }
    replace(urlOrLocation) {
        this._pushOrReplace(urlOrLocation, true);
    }
    listen(callback) {
        const id = `listener-${++uid}`;
        this.listeners[id] = callback;
        return () => delete this.listeners[id];
    }
    _pushOrReplace(urlOrLocation, replace) {
        let location;
        if (typeof urlOrLocation === 'string') {
            location = toLocation(urlOrLocation, this.settings);
        }
        else {
            location = urlOrLocation;
        }
        this._pushLocation(location, replace);
        Object.values(this.listeners).forEach((listener) => {
            listener(location, {
                settings: this.settings,
                i18n: this.i18n,
            });
        });
    }
}
//# sourceMappingURL=LocalRouter.js.map