import { AppContext } from './app';
import { Class } from './object';
import { AnyState, State } from './state';
export declare const reducers: unique symbol;
export declare const types: unique symbol;
export declare const sagas: unique symbol;
export declare const dispatch: unique symbol;
export declare const combinedReducers: unique symbol;
export declare const inReducer: unique symbol;
export declare const run: unique symbol;
export declare const stop: unique symbol;
export declare const serviceClass: unique symbol;
export declare const create: unique symbol;
export declare const sagasFromReducers: unique symbol;
export interface Service<S extends State = AnyState> {
    [reducers]: any;
    [types]: any;
    [sagas]: any;
    [dispatch]: any;
    [combinedReducers]: (state: any, action: any) => any;
    [inReducer]: boolean;
    state: S;
    [k: string]: any;
    [create](initialState: S): void;
    [run](): void;
    [stop](): void;
    [sagasFromReducers]: any;
}
export interface AppService<S extends State = AnyState> extends Service<S> {
    context: AppContext;
}
export interface GlobalService<S extends State = AnyState> extends AppService<S> {
}
export interface LocalService<S extends State = AnyState> extends AppService<S> {
}
export interface ServiceFactory {
    createService: <S extends State, T extends AppService<S>>(ctor: Class<T>, context: AppContext, initialState: S) => T;
}
