import { AnonymousObject, NestedKeyOf, PathType } from '../types/object';
export declare const LOADING: unique symbol;
export declare function applyMixins(derivedCtor: any, constructors: any[]): void;
export declare function isNull(value: any): boolean;
export declare function isNullOrEmpty(value: any): boolean;
export declare function or(value: any, defaultValue: any): any;
export declare function deepFreeze(object: AnonymousObject): Readonly<AnonymousObject>;
export declare function isObject(item: any): boolean;
export declare function simpleMergeDeep(target: any, source: any): any;
export declare function mergeDefault(obj: any, defaults: any): any;
export declare function clone(item: any): any;
export declare function del(content: any, property: string | number): any;
export declare function find(content: any, property: string | number, populate?: boolean): any[];
export declare function get<T>(content: T, property?: undefined, defaultValue?: T): T;
export declare function get<T, K extends NestedKeyOf<T> = NestedKeyOf<T>>(content: T | null | undefined, property: K, defaultValue: Exclude<PathType<T, K>, undefined | null>): Exclude<PathType<T, K>, undefined | null>;
export declare function get<T, K extends NestedKeyOf<T> = NestedKeyOf<T>>(content: T | null | undefined, property: K, defaultValue?: PathType<T, K>): PathType<T, K>;
export declare function get<T, K extends NestedKeyOf<T> = NestedKeyOf<T>>(content?: T | null, property?: K, defaultValue?: PathType<T, K>): PathType<T, K> | undefined;
export declare function get<T, K extends NestedKeyOf<T> = NestedKeyOf<T>>(content?: T | null, property?: K, defaultValue?: PathType<T, K> | null): PathType<T, K> | null;
export declare function append<T>(content: T, property: string | number, value: any): T;
export declare function set<T, K extends NestedKeyOf<T> = NestedKeyOf<T>>(content: T | undefined, property: K, value: PathType<T, K>, force?: boolean): T;
export declare function update<T>(content: T, property: string | number, fn: {
    (arr: any[]): any[];
    (arg0: any): any;
}): T;
/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * Performs equality by iterating through keys on an object and returning false
 * when any key has values which are not strictly equal between the arguments.
 * Returns true when the values of all keys are strictly equal.
 */
export declare function shallowEqual(objA: any, objB: any): boolean;
export declare function useShallowEqual<T = any>(obj: AnonymousObject<T>): AnonymousObject<T>;
export declare const diffArrays: (arr1: any[], arr2: any[]) => {
    added: any[];
    removed: any[];
    same: any[];
};
export declare const toPayload: (args: any) => AnonymousObject<any>;
export declare const fromPayload: (payload: AnonymousObject) => any[];
export declare const omit: <T, S = any>(source: S, keys: (keyof S)[]) => T;
export declare const pick: <T>(source: T & {
    [k: string]: any;
}, keys: (keyof T)[]) => T;
export declare const isGetter: (obj: any, property: string) => boolean;
export declare const isSetter: (obj: any, property: string) => boolean;
export declare const isGetterOrSetter: (obj: any, property: string) => boolean;
export declare const toArray: <T>(a: T | T[] | undefined) => T[];
export declare const ensureFieldValue: <T, K extends keyof T>(object: T, field: K, value?: T[K] | undefined) => T;
export declare const isDictionary: (object: unknown) => object is Record<string | number | symbol, unknown>;
