// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
export function isTrue(value) {
    return value === 'true' || value === true;
}
// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
export function isFalse(value) {
    return value === 'false' || value === false;
}
// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
export function isFunction(value) {
    return typeof value === 'function';
}
// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
export function isPromise(value) {
    if (!value)
        return false;
    return typeof value.then == 'function';
}
// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
export function isAsyncFunction(value) {
    if (!value || !value.constructor)
        return false;
    return value.constructor.name === 'AsyncFunction';
}
// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
export function isFunctionOrPromise(value) {
    return isFunction(value) || isPromise(value);
}
// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
export function isAsyncOrPromise(value) {
    return isAsyncFunction(value) || isPromise(value);
}
export function isInteger(str) {
    return /^(0|[1-9]\d*)$/.test(str);
}
// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
export function ensureType(value, type) {
    if (!Array.isArray(type)) {
        type = [type];
    }
    if (!type.includes(typeof value)) {
        throw new Error(`Invalid type for value "${value}. Only supported types are ${type.join(',')}`);
    }
}
//# sourceMappingURL=type.js.map