import 'reflect-metadata';
import { Class } from '../types/object';
import { AppService, Service, ServiceFactory } from '../types/service';
import { State } from '../types/state';
import AppContext from './AppContext';
export default class Container implements ServiceFactory {
    private classRegistry;
    private instanceRegistry;
    constructor();
    addServiceClass<S extends State, T extends Service<S>>(ctor: Class<T>, force?: boolean): void;
    getServiceClass<S extends State, T extends Service<S>>(ctor: Class<T>): Class<T>;
    createService<S extends State, T extends AppService<S>>(ctor: Class<T>, context: AppContext, initialState: S): T;
}
