import { Middleware } from 'redux';
import DefaultBasicError from '../core/BasicError';
import { AppSettings, AppStore } from '../types/app';
import { ResultCallback, SuccessCallback } from '../types/callback';
import { BasicError, ErrorCallback } from '../types/error';
import { AnonymousObject } from '../types/object';
import { Router } from '../types/router';
import BasicAppContext from './AppContext';
import { AppErrorCallback, AppResultCallback, AppSuccessCallback } from './typings';
export declare const createReduxStore: (initialState?: AnonymousObject, middlewares?: Middleware<any, any, any>[]) => AppStore;
export declare const formatSettings: (settings: AppSettings) => AppSettings;
export declare function asResultCallback<T = any>(callback: AppResultCallback<T> | undefined, router: Router, appContext: BasicAppContext): ResultCallback<T> | undefined;
export declare function useErrorCallback<T extends BasicError = DefaultBasicError>(callback?: AppErrorCallback<T>, defaultCallback?: AppErrorCallback<T>): ErrorCallback<T> | undefined;
export declare function useSuccessCallback<T = any>(callback?: AppSuccessCallback<T>, defaultCallback?: AppSuccessCallback<T>): SuccessCallback<T> | undefined;
