import DefaultLocalService from '../app/LocalService';
import DefaultBasicError from '../core/BasicError';
import NotificationService from '../notification/NotificationService';
import { SuccessCallback } from '../types/callback';
import { ErrorCallback } from '../types/error';
import AuthService from './AuthService';
import { LogoutState } from './typings';
export default class LogoutService extends DefaultLocalService<LogoutState> {
    notificationService: NotificationService;
    authService: AuthService;
    constructor(notificationService: NotificationService, authService: AuthService);
    /**
     * Inform the user if there is a loading task
     *
     * @param {boolean} loading
     */
    setLoading(loading: boolean): void;
    /**
     * Inform the user if there is an error
     *
     * @param {object} error
     */
    onError(error: DefaultBasicError): void;
    /**
     * Reset the loading and error message after a successful operation
     *
     */
    onSuccess(): void;
    /**
     * Logout the user or redirect to an external logout page
     *
     * @param onError callback for catching possible errors
     * @param onSuccess callback called after a success logout
     */
    logout(onError?: ErrorCallback, onSuccess?: SuccessCallback, identity?: string): Generator<string | void | Promise<any> | Generator<void | Generator<void, void, unknown> | import("redux-saga/effects").CallEffect<void>, void, unknown>, void, string>;
    successLogout(onError?: ErrorCallback, onSuccess?: SuccessCallback, identity?: string): Generator<void | Generator<void, void, unknown> | import("redux-saga/effects").CallEffect<void>, void, unknown>;
}
