import { Task } from '@redux-saga/types';
import { FetchMethod, FetchOptions, FetchState } from '../types/fetch';
import DefaultService from './Service';
export default class FetchService<S extends FetchState = FetchState> extends DefaultService<S> {
    pollTask?: Task;
    delayLoading(delay_ms?: number): Generator<void | import("redux-saga/effects").CallEffect<true>, void, unknown>;
    delete<R = any>(url: string, options?: FetchOptions<R>): Generator<Generator<void | import("redux-saga/effects").ForkEffect<Generator<void | import("redux-saga/effects").CallEffect<true>, void, unknown>> | Promise<any> | import("redux-saga/effects").CancelEffect | import("redux-saga/effects").CallEffect<unknown>, void, Task<any> & Response>, void, unknown>;
    fetchError(e: any): void;
    fetchSuccess(result: any): void;
    fetch<R = any>(url: string, method: FetchMethod, body?: unknown, options?: FetchOptions<R>): Generator<void | import("redux-saga/effects").ForkEffect<Generator<void | import("redux-saga/effects").CallEffect<true>, void, unknown>> | Promise<any> | import("redux-saga/effects").CancelEffect | import("redux-saga/effects").CallEffect<unknown>, void, Task<any> & Response>;
    get<R = any>(url: string, options?: FetchOptions<R>): any;
    pollFetch<R = any>(url: string, fixedRateInMs: number | ((result: R | undefined) => number), options?: FetchOptions<any>): any;
    poll<R = any>(url: string, fixedRateInMs: number | ((result: R | undefined) => number), options?: FetchOptions<any>): any;
    cancelPoll(): Generator<void | undefined, void, unknown>;
    patch<R = any>(url: string, body: unknown, options?: FetchOptions<R>): Generator<Generator<void | import("redux-saga/effects").ForkEffect<Generator<void | import("redux-saga/effects").CallEffect<true>, void, unknown>> | Promise<any> | import("redux-saga/effects").CancelEffect | import("redux-saga/effects").CallEffect<unknown>, void, Task<any> & Response>, void, unknown>;
    post<R = any>(url: string, body: unknown, options?: FetchOptions<R>): Generator<Generator<void | import("redux-saga/effects").ForkEffect<Generator<void | import("redux-saga/effects").CallEffect<true>, void, unknown>> | Promise<any> | import("redux-saga/effects").CancelEffect | import("redux-saga/effects").CallEffect<unknown>, void, Task<any> & Response>, void, unknown>;
    put<R = any>(url: string, body: unknown, options?: FetchOptions<R>): Generator<Generator<void | import("redux-saga/effects").ForkEffect<Generator<void | import("redux-saga/effects").CallEffect<true>, void, unknown>> | Promise<any> | import("redux-saga/effects").CancelEffect | import("redux-saga/effects").CallEffect<unknown>, void, Task<any> & Response>, void, unknown>;
    setLoading(loading: boolean, fetching: boolean): void;
}
