import { ReactNode } from 'react';
import DefaultGlobalService from '../app/GlobalService';
import { AppSettings } from '../types/app';
import { Notification, NotificationContent, NotificationLevel } from './typings';
export default class NotificationService extends DefaultGlobalService {
    init(): void;
    add(notification: Notification): void;
    clearTopic(topic: string): void;
    clearAll(): void;
    debug(payload: any): Generator<Generator<void | Generator<void | import("redux-saga/effects").CallEffect<true>, void, unknown>, void, unknown>, void, unknown>;
    error(payload: any): Generator<Generator<void | Generator<void | import("redux-saga/effects").CallEffect<true>, void, unknown>, void, unknown>, void, unknown>;
    formatNotification(notificationContent: NotificationContent | ReactNode, settings: AppSettings, notificationService: NotificationService): Notification;
    formatLevelNotification(level: NotificationLevel, payload: any): NotificationContent;
    getNotification(notificationId: string | number | symbol): Notification | void;
    info(payload: any): Generator<Generator<void | Generator<void | import("redux-saga/effects").CallEffect<true>, void, unknown>, void, unknown>, void, unknown>;
    onRouteChange(): void;
    remove(notificationId: string | number | symbol): void;
    send(notificationContent: NotificationContent | ReactNode): Generator<void | Generator<void | import("redux-saga/effects").CallEffect<true>, void, unknown>, void, unknown>;
    success(payload: any): Generator<Generator<void | Generator<void | import("redux-saga/effects").CallEffect<true>, void, unknown>, void, unknown>, void, unknown>;
    /**
     * This method is called whenever the auto-removal of the notification should be suspended
     * @param notificationId
     */
    touch(notificationId: string | number | symbol, permanent?: boolean): void;
    /**
     * This method is called whenever the auto-removal of the notification should be reactivated
     * @param notificationId
     */
    untouch(notificationId: string | number | symbol): Generator<Generator<void | import("redux-saga/effects").CallEffect<true>, void, unknown>, void, unknown>;
    warning(payload: any): Generator<Generator<void | Generator<void | import("redux-saga/effects").CallEffect<true>, void, unknown>, void, unknown>, void, unknown>;
    _setExpires(notificationId: string | number | symbol, expires: number | null): void;
    _delayRemove(notification: Notification): Generator<void | import("redux-saga/effects").CallEffect<true>, void, unknown>;
}
